#!/usr/bin/env python

#
#Copyrigt (c) 2008
#		Matt Smith <melkor@orangepalantir.org>
#
#This file is part of GraphCutie,This file is part of Foobar.
#
#GraphCutie is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#GraphCutie is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with GraphCutie, in the file COPYING.  
#If not, see <http://www.gnu.org/licenses/>.
#
#GraphCutie uses both python and PyQT, GPL version.  The copyright notices
#can be found in copyright_notice.txt

try:
	from PyQt4 import QtGui,QtCore,QtSvg
except:
	print "you need PyQt4 to use this application as a python script"
import sys,os

class SVGWidget(QtSvg.QSvgWidget):
	"""SVG Window"""
	def __init__(self,svgplot,parent=None):
		QtSvg.QSvgWidget.__init__(self,parent)
		
		#for a default image
		#serialized_data = QtCore.QByteArray.fromRawData(svgfile)
		#self.load(serialized_data)
		self.Sdata = ""
		pal = QtGui.QPalette(self.palette())
		pal.setColor(QtGui.QPalette.Window,QtGui.QColor('white'))
		self.setAutoFillBackground(True)
		self.setPalette(pal)
		self.Graph = PlotThread(svgplot,parent)
		self.connect(self.Graph,QtCore.SIGNAL("prepared( QString )"),self.ReDraw)
	def ReDraw(self,newdata):
		self.Sdata = str(newdata)
		serialized_data = QtCore.QByteArray.fromRawData(newdata)
		self.load(serialized_data)
		self.emit(QtCore.SIGNAL("attention(int)"),1)
	def SaveImage(self,filename):
		svgwindow = self.renderer()
		newimage = QtGui.QPixmap(svgwindow.viewBox().size())
		newpainter = QtGui.QPainter()
		newpainter.begin(newimage)
		svgwindow.render(newpainter)
		newpainter.end()
		newimage.save(filename)
		
class PlotThread(QtCore.QThread):
	def __init__(self,svgplot,parent=None):
		QtCore.QThread.__init__(self,parent)
		self.Graph = svgplot
		self.cc = parent.Calculator
		self.Steps = 1000
		parent.connect(self,QtCore.SIGNAL("plotError(const QString&)"),parent.ErrorMessage)
	def Plot(self):
		data = self.parent().PC.Report()
		dx = (data[1] - data[0])/self.Steps	
		plots = []
		for thing in self.parent().Functions:
			s_fun,color = thing.PlotReply()
			if s_fun:
				try:
					check,fname = self.cc.set(s_fun)
				except:
					estring = "Function Not well formatted"
					self.emit(QtCore.SIGNAL("plotError( const QString&)"),QtCore.QString(estring))
				x = [data[0] + i*dx for i in xrange(self.Steps)]
				try:
					y = [self.cc(item) for item in x]
				except  ValueError,e:
					estring = "Evaluation Error: %s"%e
					self.emit(QtCore.SIGNAL("plotError( const QString&)"),QtCore.QString(estring))
				except IndexError,e:
					estring = "Trailing Operator: %s"%e
					self.emit(QtCore.SIGNAL("plotError( const QString&)"),QtCore.QString(estring))
				except ZeroDivisionError,e:
					estring = "Divide By Zero: %s"%e
					self.emit(QtCore.SIGNAL("plotError( const QString&)"),QtCore.QString(estring))
				else:
					plots.append((x,y,color,fname))
		if len(plots)>0:
			SvgData = self.Graph.ShowGraph(plots,Auto=data[4],ly=data[2],my=data[3])
			self.emit(QtCore.SIGNAL("prepared( QString )"),SvgData)
	def SetSteps(self,steps):
		self.Steps = steps