#!/usr/bin/env python

#
#Copyrigt (c) 2008
#		Matt Smith <melkor@orangepalantir.org>
#
#This file is part of GraphCutie,This file is part of Foobar.
#
#GraphCutie is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#GraphCutie is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with GraphCutie, in the file COPYING.  
#If not, see <http://www.gnu.org/licenses/>.
#
#GraphCutie uses both python and PyQT, GPL version.  The copyright notices
#can be found in copyright_notice.txt

"""This is the menu bar"""

from PyQt4 import QtGui,QtCore
import os,time
from showhelp import HelpBrowser
from QtDisplay import PATHNAME

class MyMenu(QtGui.QMenuBar):
	def __init__(self,parent=None):
		QtGui.QMenuBar.__init__(self,parent)
		Image = self.addMenu('image')
		SI = Image.addAction('save as image')
		self.connect(SI,QtCore.SIGNAL("triggered()"),self.SaveImage)
		SV = Image.addAction('save as svg file')
		self.connect(SV,QtCore.SIGNAL("triggered()"),self.SaveSVG)
		
		Script = self.addMenu('script')
		SaveScript = Script.addAction('save')
		LoadScript = Script.addAction('load')
		self.connect(LoadScript,QtCore.SIGNAL("triggered()"),self.LoadScript)
		self.connect(SaveScript,QtCore.SIGNAL("triggered()"),self.SaveScript)
		Help = self.addMenu('help')
		About = Help.addAction('about')
		self.connect(About,QtCore.SIGNAL("triggered()"),self.About)
		Help = Help.addAction('help')
		self.connect(Help,QtCore.SIGNAL("triggered()"),self.Help)
		
		
	def SaveScript(self):
		"""gets a filename and the prepared script then saves it."""
		filename = QtGui.QFileDialog.getSaveFileName(None,"Save As",".","*.plt")
		if filename:
			output = self.PrepareScript()
			outfile = open(filename,'w')
			outfile.write(output)
			outfile.close()
	def LoadScript(self):
		"""loads a script and executes the commands via the calculator"""
		filename = QtGui.QFileDialog.getOpenFileName(None,"Load Script",".","*.plt")
		if filename:
			infile = open(filename,'r')
			indata = infile.readlines()
			infile.close()
			plot_funs = ['F1(x)','F2(x)','F3(x)','F4(x)']
			plots = False
			for item in indata:
				if item.startswith('#') or item.startswith('plot'):
					pass
				elif item[0:5] in plot_funs:
					self.emit(QtCore.SIGNAL("LoadPlot( QString )"),item)
					plots = True
				else:
					self.emit(QtCore.SIGNAL("Calculate( QString )"),item)
					print "sending to calculator"
			if plots==True:
				self.emit(QtCore.SIGNAL("PlotRequest()"))
				
	def PrepareScript(self):
		"""This will query the GuiCalculator for the history of valid entrys, literally translate assignments and change calculations to print statements and return a string version of the complete script file."""
		rawscript = self.parent().centralWidget().GC.Script
		output = ["#PyCalc generated gnuplot script.",
		"#For use with gnuplot or PyCalc.",
		"#Create: %s"%time.strftime("%A %B %d, %Y")]
		plots = []
		for item in rawscript:
			if '=' in item:
				output.append(str(item).replace("^","**"))
		for item in self.parent().centralWidget().Functions:
			ret_fun = item.PlotReply()
			if ret_fun[0]:
				output.append(ret_fun[0].replace("^","**"))
				plots.append(item.fname[:-1])
		if len(plots)>0:
			output.append("plot %s"%','.join(plots))
		return '\n'.join(output)
		
	def SaveImage(self):
		filename = QtGui.QFileDialog.getSaveFileName(None,"Save As",".","*.png ; *.bmp ; *.jpg")
		self.emit(QtCore.SIGNAL("imageSaveRequest( QString )"),filename)
		
	def SaveSVG(self):
		filename = QtGui.QFileDialog.getSaveFileName(None,"Save As",".","*.svg")
		sdata = str(self.parent().centralWidget().MainPlot.Sdata)
		if filename:
			outfile = open(filename,'w')
			outfile.write(sdata)
			outfile.close()
	def Help(self):
		self.h = HelpBrowser(None)
		self.h.resize(400,500)
		self.h.move(400,0)
		self.h.show()
		print "showing"
	def About(self):
		intext = file(os.path.join(PATHNAME,'readme.txt'),'r').read()
		showme = QtGui.QMessageBox(None)
		showme.setText(intext)
		showme.exec_()
