#!/usr/bin/env python

#
#Copyrigt (c) 2008
#		Matt Smith <melkor@orangepalantir.org>
#
#This file is part of GraphCutie,This file is part of Foobar.
#
#GraphCutie is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#GraphCutie is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with GraphCutie, in the file COPYING.  
#If not, see <http://www.gnu.org/licenses/>.
#
#GraphCutie uses both python and PyQT, GPL version.  The copyright notices
#can be found in copyright_notice.txt

"""This is my backend for creating graphs from two lists of data

Current development.  This plots functions and scales them, on deck:
improve the current svg file situation.  Essentiall rewrite this part with better svg tools.
"""

class svgfile():
	def __init__(self):
		self.data = ''
	def open(self):
		pass
	def close(self):
		pass
	def write(self,data):
		self.data += data
	def __str__(self):
		return self.data

class SvgPlot():
	def __init__(self):
		self.Xmin = -10.0
		self.Xmax = 10
		self.Ymin = -1.0
		self.Ymax = 1
		self.Auto = True
	def ShowGraph(self,data,Auto=True,ly=0,my=0):
		minx = min(data[0][0])
		maxx = max(data[0][0])
		self.opts = {'tpos':25}
		self.Auto=Auto
		if self.Auto:
			miny,maxy = self.GetMinMaxY(data)
			self.CreateRange(minx,maxx,miny,maxy)
		else:
			self.CreateRange(minx,maxx,ly,my)
		ALLPLOTS = ""
		for item in data:
			self.CreatePath(item[0],item[1])
			self.opts['color'] = item[2]
			self.opts['fname'] = item[3]
			self.opts['tpos'] += 12
			ALLPLOTS += PLOT%self.opts
		return HEAD_SVG+VERTICAL_SCALE_SVG%self.YMarkers+HORIZONTAL_SCALE_SVG%self.XMarkers+ALLPLOTS + END
	def CreatePath(self,x,y):
		"""Given that M58.8,16.6 L58.8,444.0 L574.4,444.0 L574.4,16.6 L58.8,16.6 is my bounding box xmin ymin correspond to
		xmin ~ 58.8
		ymin ~ 444.0
		xmax ~ 574.4
		ymax ~ 16.6
		 """
		hpixels = 574.4 - 58.8
		vpixels = 444.0 -16.6
		dx = (hpixels)/(self.Xmax - self.Xmin)
		dy = (vpixels)/(self.Ymax - self.Ymin)
		pd = 'M515.6,%(tp)s L557.8,%(tp)s'%{'tp':self.opts['tpos'] + 8}
		tag = 'M'
		for i in xrange(len(x)):
			if x[i]>=self.Xmin and y[i]>=self.Ymin and x[i]<=self.Xmax and y[i] <= self.Ymax:
				px = 58.8 + dx*(x[i]-self.Xmin)
				py = 444 - dy*(y[i]-self.Ymin)
				pd +='%s%s,%s '%(tag,px,py)
				tag='L'
			else:
				tag='M'
		self.opts['pathdata'] = pd
	def GetMinMaxY(self,data):
		bigylist = []
		for item in data:
			bigylist.extend(item[1])
		minny,maxxy = min(bigylist),max(bigylist)
		if minny == maxxy:
			minny = minny -1
			maxxy = maxxy +1
		return minny,maxxy
		
	def CreateRange(self,minx,maxx,miny,maxy):
		self.Xmin = minx
		self.Xmax = maxx
		if self.Auto==True:
			yr = (maxy - miny)
			self.Ymin = miny - 0.1*yr
			self.Ymax = maxy + 0.1*yr
		else:
			self.Ymin = miny
			self.Ymax = maxy
		xr = self.Xmax - self.Xmin
		yr = self.Ymax - self.Ymin
		dy = yr/10.
		self.YMarkers = tuple(['%0.3f'%(dy*i + self.Ymin) for i in range(11)])
		dx = xr/4.
		self.XMarkers = tuple(['%0.3f'%(dx*i + self.Xmin) for i in range(5)])

HEAD_SVG = """<?xml version="1.0" encoding="utf-8"  standalone="no"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" 
 "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
<svg width="600" height="480" viewBox="0 0 600 480"
 xmlns="http://www.w3.org/2000/svg"
 xmlns:xlink="http://www.w3.org/1999/xlink">
<desc>Show Plot</desc>

<defs>


	<circle id='gpDot' r='1'/>
	<path id='gpPt0' style='stroke-width:0.222' d='M-1,0 h2 M0,-1 v2'/>
	<path id='gpPt1' style='stroke-width:0.222' d='M-1,-1 L1,1 M1,-1 L-1,1'/>
	<path id='gpPt2' style='stroke-width:0.222' d='M-1,0 L1,0 M0,-1 L0,1 M-1,-1 L1,1 M-1,1 L1,-1'/>
	<rect id='gpPt3' style='stroke-width:0.222' x='-1' y='-1' width='2' height='2'/>
	<use xlink:href='#gpPt3' id='gpPt4' style='fill:currentColor; stroke:none'/>
	<circle id='gpPt5' style='stroke-width:0.222' cx='0' cy='0' r='1'/>
	<use xlink:href='#gpPt5' id='gpPt6' style='fill:currentColor; stroke:none'/>
	<path id='gpPt7' style='stroke-width:0.222' d='M0,-1.33 L-1.33,0.67 L1.33,0.67 z'/>
	<use xlink:href='#gpPt7' id='gpPt8' style='fill:currentColor; stroke:none'/>
	<use xlink:href='#gpPt7' id='gpPt9' transform='rotate(180)'/>
	<use xlink:href='#gpPt9' id='gpPt10' style='fill:currentColor; stroke:none'/>
	<use xlink:href='#gpPt3' id='gpPt11' transform='rotate(45)'/>
	<use xlink:href='#gpPt11' id='gpPt12' style='fill:currentColor; stroke:none'/>
</defs>
<g style="fill:none; color:white; stroke:currentColor; stroke-width:1.00; stroke-linecap:butt; stroke-linejoin:miter">
</g>
<rect width="600" height="480"
style="fill:rgb(255,255,255)"/>

"""
VERTICAL_SCALE_SVG ="""
<g style="fill:none; color:black; stroke:currentColor; stroke-width:1.00; stroke-linecap:butt; stroke-linejoin:miter">
	<path d='M58.8,444.0 L67.8,444.0 M574.4,444.0 L565.4,444.0 '></path>
	<path d='M58.8,401.3 L67.8,401.3 M574.4,401.3 L565.4,401.3 '></path>
	<path d='M58.8,358.5 L67.8,358.5 M574.4,358.5 L565.4,358.5 '></path>
	<path d='M58.8,315.8 L67.8,315.8 M574.4,315.8 L565.4,315.8 '></path>
	<path d='M58.8,273.0 L67.8,273.0 M574.4,273.0 L565.4,273.0 '></path>
	<path d='M58.8,230.3 L67.8,230.3 M574.4,230.3 L565.4,230.3 '></path>
	<path d='M58.8,59.3 L67.8,59.3 M574.4,59.3 L565.4,59.3 '></path>
	<path d='M58.8,16.6 L67.8,16.6 M574.4,16.6 L565.4,16.6 '></path>
	<path d='M58.8,187.6 L67.8,187.6 M574.4,187.6 L565.4,187.6 '></path>
	
	<g transform="translate(50.5,448.5)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<g transform="translate(50.5,405.8)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<g transform="translate(50.5,363.0)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<g transform="translate(50.5,320.3)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<g transform="translate(50.5,277.5)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<g transform="translate(50.5,234.8)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<g transform="translate(50.5,192.1)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<path d='M58.8,144.8 L67.8,144.8 M574.4,144.8 L565.4,144.8 '></path>
	<g transform="translate(50.5,149.3)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<path d='M58.8,102.1 L67.8,102.1 M574.4,102.1 L565.4,102.1 '></path>
	<g transform="translate(50.5,106.6)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<g transform="translate(50.5,63.8)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
	<g transform="translate(50.5,21.1)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text> %s</text>
	</g>
"""
HORIZONTAL_SCALE_SVG= """
	<path d='M58.8,444.0 L58.8,435.0 M58.8,16.6 L58.8,25.6 '></path>
	<path d='M187.7,444.0 L187.7,435.0 M187.7,16.6 L187.7,25.6 '></path>
	<path d='M316.6,444.0 L316.6,435.0 M316.6,16.6 L316.6,25.6 '></path>
	<path d='M574.4,444.0 L574.4,435.0 M574.4,16.6 L574.4,25.6 '></path>
	<path d='M445.5,444.0 L445.5,435.0 M445.5,16.6 L445.5,25.6 '></path>
	<path d='M58.8,16.6 L58.8,444.0 L574.4,444.0 L574.4,16.6 L58.8,16.6 Z '></path>
	<g transform="translate(58.8,466.5)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:middle">
		<text>%s</text>
	</g>
	<g transform="translate(187.7,466.5)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:middle">
		<text>%s</text>
	</g>
	<g transform="translate(316.6,466.5)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:middle">
		<text> %s</text>
	</g>
	<g transform="translate(445.5,466.5)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:middle">
		<text> %s</text>
	</g>
	<g transform="translate(574.4,466.5)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:middle">
		<text> %s</text>
	</g>
</g>
"""
PLOT ="""
<g style="fill:none; color:%(color)s; stroke:currentColor; stroke-width:1.00; stroke-linecap:butt; stroke-linejoin:miter">
</g>
<g style="fill:none; color:black; stroke:currentColor; stroke-width:1.00; stroke-linecap:butt; stroke-linejoin:miter">
	<g transform="translate(507.3,%(tpos)s)" style="stroke:none; fill:black; font-family:Arial; font-size:12.00pt; text-anchor:end">
		<text>%(fname)s </text>
	</g>
</g>
<g style="fill:none; color:%(color)s; stroke:currentColor; stroke-width:1.00; stroke-linecap:butt; stroke-linejoin:miter">
	<path d='%(pathdata)s'></path>
</g>"""

END = """
<g style="fill:none; color:black; stroke:currentColor; stroke-width:1.00; stroke-linecap:butt; stroke-linejoin:miter">
	<path d='M58.8,16.6 L58.8,444.0 L574.4,444.0 L574.4,16.6 L58.8,16.6 Z '></path>
</g>
</svg>
"""